Makefile.am 9.37 KB
Newer Older
1 2 3 4 5
# Ganeti makefile
# - Indent with tabs only.
# - Keep files sorted; one line per file.
# - Directories in lib/ must have their own *dir variable (see hypervisor).
# - All directories must be listed DIRS.
Michael Hanselmann's avatar
Michael Hanselmann committed
6
# - Use autogen.sh to generate Makefile.in and configure script.
7 8 9 10 11

# Automake doesn't export these variables before version 1.10.
abs_top_builddir = @abs_top_builddir@
abs_top_srcdir = @abs_top_srcdir@

12
ACLOCAL_AMFLAGS = -I autotools
13 14 15 16
DOCBOOK_WRAPPER = $(top_srcdir)/autotools/docbook-wrapper
REPLACE_VARS_SED = autotools/replace_vars.sed

hypervisordir = $(pkgpythondir)/hypervisor
17
httpdir = $(pkgpythondir)/http
18
rapidir = $(pkgpythondir)/rapi
19 20 21 22 23 24 25 26 27 28
toolsdir = $(pkglibdir)/tools
docdir = $(datadir)/doc/$(PACKAGE)

DIRS = \
	autotools \
	daemons \
	devel \
	doc \
	doc/examples \
	lib \
29
	lib/http \
30
	lib/hypervisor \
31
	lib/rapi \
32 33 34 35 36 37 38
	man \
	qa \
	scripts \
	test \
	test/data \
	tools

Iustin Pop's avatar
Iustin Pop committed
39
MAINTAINERCLEANFILES = \
40
	$(docpng) \
Iustin Pop's avatar
Iustin Pop committed
41 42
	$(maninput)

43 44 45
maintainer-clean-local:
	-rm -rf doc/api doc/build doc/html

46 47 48
CLEANFILES = \
	autotools/replace_vars.sed \
	devel/upload \
49
	doc/examples/bash_completion \
50 51 52
	doc/examples/ganeti.initd \
	doc/examples/ganeti.cron \
	lib/*.py[co] \
53
	lib/http/*.py[co] \
54
	lib/hypervisor/*.py[co] \
55
	lib/rapi/*.py[co] \
Iustin Pop's avatar
Iustin Pop committed
56 57
	$(man_MANS) \
	$(manhtml) \
58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74
	qa/*.py[co] \
	test/*.py[co] \
	stamp-directories \
	$(nodist_pkgpython_PYTHON)

nodist_pkgpython_PYTHON = \
	lib/_autoconf.py

pkgpython_PYTHON = \
	lib/__init__.py \
	lib/backend.py \
	lib/bdev.py \
	lib/bootstrap.py \
	lib/cli.py \
	lib/cmdlib.py \
	lib/config.py \
	lib/constants.py \
75
	lib/daemon.py \
76 77
	lib/errors.py \
	lib/jqueue.py \
78
	lib/jstore.py \
79 80 81 82 83 84 85 86 87
	lib/locking.py \
	lib/luxi.py \
	lib/mcpu.py \
	lib/objects.py \
	lib/opcodes.py \
	lib/rpc.py \
	lib/serializer.py \
	lib/ssconf.py \
	lib/ssh.py \
88 89
	lib/utils.py \
	lib/workerpool.py
90 91 92 93 94

hypervisor_PYTHON = \
	lib/hypervisor/__init__.py \
	lib/hypervisor/hv_base.py \
	lib/hypervisor/hv_fake.py \
Guido Trotter's avatar
Guido Trotter committed
95
	lib/hypervisor/hv_kvm.py \
96 97
	lib/hypervisor/hv_xen.py

98 99
rapi_PYTHON = \
	lib/rapi/__init__.py \
100 101 102
	lib/rapi/baserlib.py \
	lib/rapi/connector.py \
	lib/rapi/rlib2.py
103

104
http_PYTHON = \
105
	lib/http/__init__.py \
106
	lib/http/auth.py \
107 108
	lib/http/client.py \
	lib/http/server.py
109

110

Michael Hanselmann's avatar
Michael Hanselmann committed
111
docrst = \
112
	doc/admin.rst \
113
	doc/design-2.0.rst \
114
	doc/hooks.rst \
115
	doc/iallocator.rst \
116
	doc/index.rst \
117
	doc/install.rst \
118
	doc/rapi.rst \
119
	doc/security.rst
Michael Hanselmann's avatar
Michael Hanselmann committed
120

121 122 123 124 125 126 127 128 129 130
doc/html: $(docrst) $(docpng) doc/conf.py configure.ac
	@test -n "$(SPHINX)" || \
	    { echo 'sphinx-build' not found during configure; exit 1; }
	mkdir -p doc/build/doctrees
	PYTHONPATH=.:$(top_builddir) sphinx-build -q -b html \
	    -d doc/build/doctrees \
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
	    -D release="$(PACKAGE_VERSION)" \
	    $(top_srcdir)/doc doc/html
	touch "$@"
Iustin Pop's avatar
Iustin Pop committed
131

132 133 134
docdot = \
	doc/arch-2.0.dot

135
docpng = $(patsubst %.dot,%.png,$(docdot))
136

137
noinst_DATA = $(manhtml) doc/html
138

139 140 141 142
dist_sbin_SCRIPTS = \
	daemons/ganeti-noded \
	daemons/ganeti-watcher \
	daemons/ganeti-masterd \
143
	daemons/ganeti-rapi \
144 145 146 147 148 149 150 151 152 153 154 155 156 157 158
	scripts/gnt-backup \
	scripts/gnt-cluster \
	scripts/gnt-debug \
	scripts/gnt-instance \
	scripts/gnt-job \
	scripts/gnt-node \
	scripts/gnt-os

dist_tools_SCRIPTS = \
	tools/burnin \
	tools/cfgshell \
	tools/cfgupgrade \
	tools/lvmstrap

EXTRA_DIST = \
Iustin Pop's avatar
Iustin Pop committed
159
	$(MAINTAINERCLEANFILES) \
160 161 162 163
	NEWS \
	DEVNOTES \
	autotools/docbook-wrapper \
	devel/upload.in \
164
	$(docdot) \
165 166 167
	$(docrst) \
	doc/conf.py \
	doc/html \
168
	doc/examples/bash_completion.in \
169 170 171
	doc/examples/ganeti.initd.in \
	doc/examples/ganeti.cron.in \
	doc/examples/dumb-allocator \
172
	doc/locking.txt \
173 174 175 176 177
	test/testutils.py \
	test/mocks.py \
	$(dist_TESTS) \
	$(TEST_FILES) \
	man/footer.sgml \
Iustin Pop's avatar
Iustin Pop committed
178
	$(mansgml) $(maninput) \
179
	qa/ganeti-qa.py \
Michael Hanselmann's avatar
Michael Hanselmann committed
180
	qa/qa-sample.json \
181 182 183 184 185 186 187 188
	qa/qa_cluster.py \
	qa/qa_config.py \
	qa/qa_daemon.py \
	qa/qa_env.py \
	qa/qa_error.py \
	qa/qa_instance.py \
	qa/qa_node.py \
	qa/qa_os.py \
Oleksiy Mishchenko's avatar
Oleksiy Mishchenko committed
189
	qa/qa_rapi.py \
190 191 192 193 194
	qa/qa_tags.py \
	qa/qa_utils.py

man_MANS = \
	man/ganeti.7 \
195
	man/ganeti-masterd.8 \
196 197
	man/ganeti-noded.8 \
	man/ganeti-os-interface.7 \
198
	man/ganeti-rapi.8 \
199 200 201
	man/ganeti-watcher.8 \
	man/gnt-backup.8 \
	man/gnt-cluster.8 \
202
	man/gnt-debug.8 \
203
	man/gnt-instance.8 \
204
	man/gnt-job.8 \
205 206 207
	man/gnt-node.8 \
	man/gnt-os.8

Iustin Pop's avatar
Iustin Pop committed
208 209 210
mansgml = $(patsubst %.7,%.sgml,$(patsubst %.8,%.sgml,$(man_MANS)))
manhtml = $(patsubst %.sgml,%.html,$(mansgml))
maninput = $(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) $(patsubst %.html,%.html.in,$(manhtml))
211 212 213 214 215 216 217 218

TEST_FILES = \
	test/data/bdev-both.txt \
	test/data/bdev-disk.txt \
	test/data/bdev-net.txt \
	test/data/proc_drbd8.txt

dist_TESTS = \
219 220 221
	test/ganeti.bdev_unittest.py \
	test/ganeti.cli_unittest.py \
	test/ganeti.cmdlib_unittest.py \
222
	test/ganeti.config_unittest.py \
223
	test/ganeti.constants_unittest.py \
224
	test/ganeti.hooks_unittest.py \
225
	test/ganeti.http_unittest.py \
226
	test/ganeti.locking_unittest.py \
227
	test/ganeti.rapi.resources_unittest.py \
228 229 230 231
	test/ganeti.serializer_unittest.py \
	test/ganeti.ssh_unittest.py \
	test/ganeti.utils_unittest.py \
	test/ganeti.workerpool_unittest.py
232 233 234 235 236 237 238 239

nodist_TESTS =

TESTS = $(dist_TESTS) $(nodist_TESTS)

TESTS_ENVIRONMENT = PYTHONPATH=.:$(top_builddir)

all-local: stamp-directories lib/_autoconf.py devel/upload \
Iustin Pop's avatar
Iustin Pop committed
240
	doc/examples/bash_completion \
241 242 243 244 245 246
	doc/examples/ganeti.initd doc/examples/ganeti.cron

devel/upload: devel/upload.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
	chmod u+x $@

Iustin Pop's avatar
Iustin Pop committed
247
doc/examples/%: doc/examples/%.in stamp-directories \
248 249 250
		$(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@

251
doc/%.png: doc/%.dot
Iustin Pop's avatar
Iustin Pop committed
252
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
253 254
	$(DOT) -Tpng -o $@ $<

Iustin Pop's avatar
Iustin Pop committed
255
man/%.7.in man/%.8.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
256
	@test -n "$(DOCBOOK2MAN)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
257 258 259 260 261 262 263
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2MAN)" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.html.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
264
	@test -n "$(DOCBOOK2HTML)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
265 266 267 268 269 270 271 272
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2HTML) --nochunks" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.7: man/%.7.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
273

Iustin Pop's avatar
Iustin Pop committed
274 275
man/%.8: man/%.8.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
276

Iustin Pop's avatar
Iustin Pop committed
277 278
man/%.html: man/%.html.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
279

280 281
man/footer.sgml $(TESTS): srclinks

282
$(TESTS): ganeti lib/_autoconf.py
283 284 285 286 287

lib/_autoconf.py: Makefile stamp-directories
	set -e; \
	{ echo '# This file is automatically generated, do not edit!'; \
	  echo '#'; \
Iustin Pop's avatar
Iustin Pop committed
288 289 290 291 292 293 294 295 296
	  echo ''; \
	  echo '"""Build-time configuration for Ganeti.'; \
	  echo '';\
	  echo 'This file is autogenerated by the build process.'; \
	  echo 'For any changes you need to re-run ./configure (and'; \
	  echo 'not edit by hand).'; \
	  echo ''; \
	  echo '"""'; \
	  echo ''; \
297 298 299 300 301 302 303 304 305 306 307 308 309 310 311
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
	  echo "SSH_INITD_SCRIPT = '$(SSH_INITD_SCRIPT)'"; \
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
312
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
Guido Trotter's avatar
Guido Trotter committed
313
	  echo "KVM_MIGRATION_PORT = '$(KVM_MIGRATION_PORT)'"; \
Guido Trotter's avatar
Guido Trotter committed
314
	  echo "SOCAT_PATH = '$(SOCAT_PATH)'"; \
315 316 317 318 319 320 321 322 323 324 325
	} > $@

$(REPLACE_VARS_SED): Makefile stamp-directories
	set -e; \
	{ echo 's#@PREFIX@#$(prefix)#g'; \
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
326
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
327 328 329 330 331 332 333
	} > $@

# We need to create symlinks because "make distcheck" will not install Python
# files when building.
#.PHONY: srclinks
srclinks: stamp-directories
	set -e; \
334 335
	for i in man/footer.sgml $(pkgpython_PYTHON) $(hypervisor_PYTHON) \
			$(rapi_PYTHON) $(http_PYTHON); do \
336 337 338 339
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
		fi; \
	done
340

Michael Hanselmann's avatar
Michael Hanselmann committed
341 342
.PHONY: ganeti
ganeti:
343
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
Michael Hanselmann's avatar
Michael Hanselmann committed
344

Iustin Pop's avatar
Iustin Pop committed
345 346 347 348 349 350 351
# a dist hook rule for catching revision control directories
distcheck-hook:
	if find $(top_distdir) | grep -F -e '.svn' -e '.git'; then \
		echo "Found revision control files in final archive" 1>&2 ; \
		exit 1; \
	fi

Iustin Pop's avatar
Iustin Pop committed
352
install-exec-local:
353
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
354 355
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
	  "$(DESTDIR)${localstatedir}/run/ganeti"
356 357 358 359 360

stamp-directories: Makefile
	@mkdir_p@ $(DIRS)
	touch $@

Iustin Pop's avatar
Iustin Pop committed
361 362 363
.PHONY: apidoc
apidoc:
	test -e doc/api || mkdir doc/api
Iustin Pop's avatar
Iustin Pop committed
364
	TMPDIR=`mktemp -d ` && { \
Iustin Pop's avatar
Iustin Pop committed
365 366
		cp -r scripts daemons lib $$TMPDIR && \
		( \
Iustin Pop's avatar
Iustin Pop committed
367
			CDIR=`pwd` && \
Iustin Pop's avatar
Iustin Pop committed
368 369
			cd $$TMPDIR && \
			mv lib ganeti && \
Iustin Pop's avatar
Iustin Pop committed
370
			epydoc -v --conf $$CDIR/epydoc.conf -o $$CDIR/doc/api \
Iustin Pop's avatar
Iustin Pop committed
371 372 373 374
		) ; \
		rm -rf $$TMPDIR ; \
	}

375
# vim: set noet :